## victoriametrics 1.53.1+ds

=== Makefile ===
PKG_PREFIX := github.com/VictoriaMetrics/VictoriaMetrics

BUILDINFO_TAG ?= $(shell echo $$(git describe --long --all | tr '/' '-')$$( \
	      git diff-index --quiet HEAD -- || echo '-dirty-'$$(git diff-index -u HEAD | openssl sha1 | cut -c 10-17)))

PKG_TAG ?= $(shell git tag -l --points-at HEAD)
ifeq ($(PKG_TAG),)
PKG_TAG := $(BUILDINFO_TAG)
endif

GO_BUILDINFO = -X '$(PKG_PREFIX)/lib/buildinfo.Version=$(APP_NAME)-$(shell date -u +'%Y%m%d-%H%M%S')-$(BUILDINFO_TAG)'

.PHONY: $(MAKECMDGOALS)

all: \
	victoria-metrics-prod \
	vmagent-prod \
	vmalert-prod \
	vmauth-prod \
	vmbackup-prod \
	vmrestore-prod \
	vmctl-prod

include app/*/Makefile
include deployment/*/Makefile

clean:
	rm -rf bin/*

publish: \
	publish-victoria-metrics \
	publish-vmagent \
	publish-vmalert \
	publish-vmauth \
	publish-vmbackup \
	publish-vmrestore \
	publish-vmctl

package: \
	package-victoria-metrics \
	package-vmagent \
	package-vmalert \
	package-vmauth \
	package-vmbackup \
	package-vmrestore \
	package-vmctl

vmutils: \
	vmagent \
	vmalert \
	vmauth \
	vmbackup \
	vmrestore \
	vmctl

vmutils-arm64: \
	vmagent-arm64 \
	vmalert-arm64 \
	vmauth-arm64 \
	vmbackup-arm64 \
	vmrestore-arm64 \
	vmctl-arm64

release-snap:
	snapcraft
	snapcraft upload "victoriametrics_$(PKG_TAG)_multi.snap" --release beta,edge,candidate

release: \
	release-victoria-metrics \
	release-vmutils

release-victoria-metrics: \
	release-victoria-metrics-amd64 \
	release-victoria-metrics-arm64

release-victoria-metrics-amd64:
	GOARCH=amd64 $(MAKE) release-victoria-metrics-generic

release-victoria-metrics-arm64:
	GOARCH=arm64 $(MAKE) release-victoria-metrics-generic

release-victoria-metrics-generic: victoria-metrics-$(GOARCH)-prod
	cd bin && \
		tar --transform="flags=r;s|-$(GOARCH)||" -czf victoria-metrics-$(GOARCH)-$(PKG_TAG).tar.gz \
			victoria-metrics-$(GOARCH)-prod \
		&& sha256sum victoria-metrics-$(GOARCH)-$(PKG_TAG).tar.gz \
			victoria-metrics-$(GOARCH)-prod \
			| sed s/-$(GOARCH)// > victoria-metrics-$(GOARCH)-$(PKG_TAG)_checksums.txt

release-vmutils: \
	release-vmutils-amd64 \
	release-vmutils-arm64

release-vmutils-amd64:
	GOARCH=amd64 $(MAKE) release-vmutils-generic

release-vmutils-arm64:
	GOARCH=arm64 $(MAKE) release-vmutils-generic

release-vmutils-generic: \
	vmagent-$(GOARCH)-prod \
	vmalert-$(GOARCH)-prod \
	vmauth-$(GOARCH)-prod \
	vmbackup-$(GOARCH)-prod \
	vmrestore-$(GOARCH)-prod \
	vmctl-$(GOARCH)-prod
	cd bin && \
		tar --transform="flags=r;s|-$(GOARCH)||" -czf vmutils-$(GOARCH)-$(PKG_TAG).tar.gz \
			vmagent-$(GOARCH)-prod \
			vmalert-$(GOARCH)-prod \
			vmauth-$(GOARCH)-prod \
			vmbackup-$(GOARCH)-prod \
			vmrestore-$(GOARCH)-prod \
			vmctl-$(GOARCH)-prod \
		&& sha256sum vmutils-$(GOARCH)-$(PKG_TAG).tar.gz \
			vmagent-$(GOARCH)-prod \
			vmalert-$(GOARCH)-prod \
			vmauth-$(GOARCH)-prod \
			vmbackup-$(GOARCH)-prod \
			vmrestore-$(GOARCH)-prod \
			vmctl-$(GOARCH)-prod \
			| sed s/-$(GOARCH)// > vmutils-$(GOARCH)-$(PKG_TAG)_checksums.txt

pprof-cpu:
	go tool pprof -trim_path=github.com/VictoriaMetrics/VictoriaMetrics@ $(PPROF_FILE)

fmt:
	GO111MODULE=on gofmt -l -w -s ./lib
	GO111MODULE=on gofmt -l -w -s ./app

vet:
	GO111MODULE=on go vet -mod=vendor ./lib/...
	GO111MODULE=on go vet -mod=vendor ./app/...

lint: install-golint
	golint lib/...
	golint app/...

install-golint:
	which golint || go install golang.org/x/lint/golint

errcheck: install-errcheck
	errcheck -exclude=errcheck_excludes.txt ./lib/...
	errcheck -exclude=errcheck_excludes.txt ./app/vminsert/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmselect/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmstorage/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmagent/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmalert/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmauth/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmbackup/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmrestore/...
	errcheck -exclude=errcheck_excludes.txt ./app/vmctl/...

install-errcheck:
	which errcheck || go install github.com/kisielk/errcheck

check-all: fmt vet lint errcheck golangci-lint

test:
	GO111MODULE=on go test -mod=vendor ./lib/... ./app/...

test-race:
	GO111MODULE=on go test -mod=vendor -race ./lib/... ./app/...

test-pure:
	GO111MODULE=on CGO_ENABLED=0 go test -mod=vendor ./lib/... ./app/...

test-full:
	GO111MODULE=on go test -mod=vendor -coverprofile=coverage.txt -covermode=atomic ./lib/... ./app/...

test-full-386:
	GO111MODULE=on GOARCH=386 go test -mod=vendor -coverprofile=coverage.txt -covermode=atomic ./lib/... ./app/...

benchmark:
	GO111MODULE=on go test -mod=vendor -bench=. ./lib/...
	GO111MODULE=on go test -mod=vendor -bench=. ./app/...

benchmark-pure:
	GO111MODULE=on CGO_ENABLED=0 go test -mod=vendor -bench=. ./lib/...
	GO111MODULE=on CGO_ENABLED=0 go test -mod=vendor -bench=. ./app/...

vendor-update:
	GO111MODULE=on go get -u -d ./lib/...
	GO111MODULE=on go get -u -d ./app/...
	GO111MODULE=on go mod tidy
	GO111MODULE=on go mod vendor

app-local:
	CGO_ENABLED=1 GO111MODULE=on go build $(RACE) -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/$(APP_NAME)$(RACE) $(PKG_PREFIX)/app/$(APP_NAME)

app-local-pure:
	CGO_ENABLED=0 GO111MODULE=on go build $(RACE) -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/$(APP_NAME)-pure$(RACE) $(PKG_PREFIX)/app/$(APP_NAME)

app-local-with-goarch:
	GO111MODULE=on go build $(RACE) -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/$(APP_NAME)-$(GOARCH)$(RACE) $(PKG_PREFIX)/app/$(APP_NAME)

quicktemplate-gen: install-qtc
	qtc

install-qtc:
	which qtc || go install github.com/valyala/quicktemplate/qtc


golangci-lint: install-golangci-lint
	golangci-lint run --exclude '(SA4003|SA1019|SA5011):' -D errcheck -D structcheck --timeout 2m

install-golangci-lint:
	which golangci-lint || curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(shell go env GOPATH)/bin v1.29.0

docs-sync:
	cp app/vmagent/README.md docs/vmagent.md
	cp app/vmalert/README.md docs/vmalert.md
	cp app/vmauth/README.md docs/vmauth.md
	cp app/vmbackup/README.md docs/vmbackup.md
	cp app/vmrestore/README.md docs/vmrestore.md
	cp app/vmctl/README.md docs/vmctl.md
	cp README.md docs/Single-server-VictoriaMetrics.md

=== app/victoria-metrics/Makefile ===
# All these commands must run from repository root.

victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) app-local

victoria-metrics-race:
	APP_NAME=victoria-metrics RACE=-race $(MAKE) app-local

victoria-metrics-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker

victoria-metrics-pure-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-pure

victoria-metrics-amd64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-amd64

victoria-metrics-arm-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-arm

victoria-metrics-arm64-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-arm64

victoria-metrics-ppc64le-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-ppc64le

victoria-metrics-386-prod:
	APP_NAME=victoria-metrics $(MAKE) app-via-docker-386

package-victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker

package-victoria-metrics-pure:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-pure

package-victoria-metrics-amd64:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-amd64

package-victoria-metrics-arm:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-arm

package-victoria-metrics-arm64:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-arm64

package-victoria-metrics-ppc64le:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-ppc64le

package-victoria-metrics-386:
	APP_NAME=victoria-metrics $(MAKE) package-via-docker-386

publish-victoria-metrics:
	APP_NAME=victoria-metrics $(MAKE) publish-via-docker

run-victoria-metrics:
	mkdir -p victoria-metrics-data
	DOCKER_OPTS='-v $(shell pwd)/victoria-metrics-data:/victoria-metrics-data' \
	APP_NAME=victoria-metrics \
	ARGS='-graphiteListenAddr=:2003 -opentsdbListenAddr=:4242 -retentionPeriod=12 -search.maxUniqueTimeseries=1000000 -search.maxQueryDuration=10m' \
	$(MAKE) run-via-docker

victoria-metrics-amd64:
	CGO_ENABLED=1 GOOS=linux GOARCH=amd64 GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-amd64 ./app/victoria-metrics

victoria-metrics-arm:
	CGO_ENABLED=0 GOOS=linux GOARCH=arm GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-arm ./app/victoria-metrics

victoria-metrics-arm64:
	CGO_ENABLED=0 GOOS=linux GOARCH=arm64 GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-arm64 ./app/victoria-metrics

victoria-metrics-ppc64le:
	CGO_ENABLED=0 GOOS=linux GOARCH=ppc64le GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-ppc64le ./app/victoria-metrics

victoria-metrics-386:
	CGO_ENABLED=0 GOOS=linux GOARCH=386 GO111MODULE=on go build -mod=vendor -ldflags "$(GO_BUILDINFO)" -o bin/victoria-metrics-386 ./app/victoria-metrics

victoria-metrics-pure:
	APP_NAME=victoria-metrics $(MAKE) app-local-pure

### Packaging as DEB - amd64
victoria-metrics-package-deb: victoria-metrics-prod
	./package/package_deb.sh amd64

### Packaging as DEB - arm64
victoria-metrics-package-deb-arm64: victoria-metrics-arm64-prod
	./package/package_deb.sh arm64

### Packaging as DEB - all
victoria-metrics-package-deb-all: \
        victoria-metrics-package-deb \
        victoria-metrics-package-deb-arm64

### Packaging as RPM - amd64
victoria-metrics-package-rpm: victoria-metrics-prod
	./package/package_rpm.sh amd64

### Packaging as RPM - arm64
victoria-metrics-package-rpm-arm64: victoria-metrics-arm64-prod
	./package/package_rpm.sh arm64

### Packaging as RPM - all
victoria-metrics-package-rpm-all: \
        victoria-metrics-package-rpm \
        victoria-metrics-package-rpm-arm64

### Packaging as both DEB and RPM - all
victoria-metrics-package-deb-rpm-all: \
        victoria-metrics-package-deb \
        victoria-metrics-package-deb-arm64 \
        victoria-metrics-package-rpm \
        victoria-metrics-package-rpm-arm64

### Packaging as snap
victoria-metrics-package-snap:
	which snapcraft || snap install snapcraft
	which multipass || snap install multipass
	snapcraft

=== app/vmagent/Makefile ===
# All these commands must run from repository root.

vmagent:
	APP_NAME=vmagent $(MAKE) app-local

vmagent-race:
	APP_NAME=vmagent RACE=-race $(MAKE) app-local

vmagent-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker

vmagent-pure-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-pure

vmagent-amd64-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-amd64

vmagent-arm-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-arm

vmagent-arm64-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-arm64

vmagent-ppc64le-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-ppc64le

vmagent-386-prod:
	APP_NAME=vmagent $(MAKE) app-via-docker-386

package-vmagent:
	APP_NAME=vmagent $(MAKE) package-via-docker

package-vmagent-pure:
	APP_NAME=vmagent $(MAKE) package-via-docker-pure

package-vmagent-amd64:
	APP_NAME=vmagent $(MAKE) package-via-docker-amd64

package-vmagent-arm:
	APP_NAME=vmagent $(MAKE) package-via-docker-arm

package-vmagent-arm64:
	APP_NAME=vmagent $(MAKE) package-via-docker-arm64

package-vmagent-ppc64le:
	APP_NAME=vmagent $(MAKE) package-via-docker-ppc64le

package-vmagent-386:
	APP_NAME=vmagent $(MAKE) package-via-docker-386

publish-vmagent:
	APP_NAME=vmagent $(MAKE) publish-via-docker

run-vmagent:
	mkdir -p vmagent-remotewrite-data
	DOCKER_OPTS='-v $(shell pwd)/vmagent-remotewrite-data:/vmagent-remotewrite-data' \
	ARGS='-remoteWrite.url=http://localhost:8428/api/v1/write' \
	APP_NAME=vmagent \
	$(MAKE) run-via-docker

vmagent-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmagent-local-with-goarch

vmagent-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmagent-local-with-goarch

vmagent-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmagent-local-with-goarch

vmagent-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmagent-local-with-goarch

vmagent-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmagent-local-with-goarch

vmagent-local-with-goarch:
	APP_NAME=vmagent $(MAKE) app-local-with-goarch

vmagent-pure:
	APP_NAME=vmagent $(MAKE) app-local-pure

=== app/vmalert/Makefile ===
# All these commands must run from repository root.

vmalert:
	APP_NAME=vmalert $(MAKE) app-local

vmalert-race:
	APP_NAME=vmalert RACE=-race $(MAKE) app-local

vmalert-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker

vmalert-pure-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-pure

vmalert-amd64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-amd64

vmalert-arm-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-arm

vmalert-arm64-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-arm64

vmalert-ppc64le-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-ppc64le

vmalert-386-prod:
	APP_NAME=vmalert $(MAKE) app-via-docker-386

package-vmalert:
	APP_NAME=vmalert $(MAKE) package-via-docker

package-vmalert-pure:
	APP_NAME=vmalert $(MAKE) package-via-docker-pure

package-vmalert-amd64:
	APP_NAME=vmalert $(MAKE) package-via-docker-amd64

package-vmalert-arm:
	APP_NAME=vmalert $(MAKE) package-via-docker-arm

package-vmalert-arm64:
	APP_NAME=vmalert $(MAKE) package-via-docker-arm64

package-vmalert-ppc64le:
	APP_NAME=vmalert $(MAKE) package-via-docker-ppc64le

package-vmalert-386:
	APP_NAME=vmalert $(MAKE) package-via-docker-386

publish-vmalert:
	APP_NAME=vmalert $(MAKE) publish-via-docker

test-vmalert:
	go test -v -race -cover ./app/vmalert -loggerLevel=ERROR
	go test -v -race -cover ./app/vmalert/datasource
	go test -v -race -cover ./app/vmalert/notifier
	go test -v -race -cover ./app/vmalert/config

run-vmalert: vmalert
	./bin/vmalert -rule=app/vmalert/config/testdata/rules2-good.rules \
		-datasource.url=http://localhost:8428 \
		-notifier.url=http://localhost:9093 \
		-notifier.url=http://127.0.0.1:9093 \
		-remoteWrite.url=http://localhost:8428 \
		-remoteRead.url=http://localhost:8428 \
		-external.label=cluster=east-1 \
		-external.label=replica=a \
		-evaluationInterval=3s

vmalert-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmalert-local-with-goarch

vmalert-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmalert-local-with-goarch

vmalert-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmalert-local-with-goarch

vmalert-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmalert-local-with-goarch

vmalert-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmalert-local-with-goarch

vmalert-local-with-goarch:
	APP_NAME=vmalert $(MAKE) app-local-with-goarch

vmalert-pure:
	APP_NAME=vmalert $(MAKE) app-local-pure

=== app/vmauth/Makefile ===
# All these commands must run from repository root.

vmauth:
	APP_NAME=vmauth $(MAKE) app-local

vmauth-race:
	APP_NAME=vmauth RACE=-race $(MAKE) app-local

vmauth-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker

vmauth-pure-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-pure

vmauth-amd64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-amd64

vmauth-arm-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-arm

vmauth-arm64-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-arm64

vmauth-ppc64le-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-ppc64le

vmauth-386-prod:
	APP_NAME=vmauth $(MAKE) app-via-docker-386

package-vmauth:
	APP_NAME=vmauth $(MAKE) package-via-docker

package-vmauth-pure:
	APP_NAME=vmauth $(MAKE) package-via-docker-pure

package-vmauth-amd64:
	APP_NAME=vmauth $(MAKE) package-via-docker-amd64

package-vmauth-arm:
	APP_NAME=vmauth $(MAKE) package-via-docker-arm

package-vmauth-arm64:
	APP_NAME=vmauth $(MAKE) package-via-docker-arm64

package-vmauth-ppc64le:
	APP_NAME=vmauth $(MAKE) package-via-docker-ppc64le

package-vmauth-386:
	APP_NAME=vmauth $(MAKE) package-via-docker-386

publish-vmauth:
	APP_NAME=vmauth $(MAKE) publish-via-docker

run-vmauth:
	APP_NAME=vmauth \
	DOCKER_OPTS='-v $(shell pwd)/app/vmauth/:/app/vmauth' \
	ARGS='-auth.config=app/vmauth/example_config.yml' \
	$(MAKE) run-via-docker

vmauth-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmauth-local-with-goarch

vmauth-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmauth-local-with-goarch

vmauth-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmauth-local-with-goarch

vmauth-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmauth-local-with-goarch

vmauth-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmauth-local-with-goarch

vmauth-local-with-goarch:
	APP_NAME=vmauth $(MAKE) app-local-with-goarch

vmauth-pure:
	APP_NAME=vmauth $(MAKE) app-local-pure

=== app/vmctl/Makefile ===
# All these commands must run from repository root.

vmctl:
	APP_NAME=vmctl $(MAKE) app-local

vmctl-race:
	APP_NAME=vmctl RACE=-race $(MAKE) app-local

vmctl-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker

vmctl-pure-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-pure

vmctl-amd64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-amd64

vmctl-arm-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-arm

vmctl-arm64-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-arm64

vmctl-ppc64le-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-ppc64le

vmctl-386-prod:
	APP_NAME=vmctl $(MAKE) app-via-docker-386

package-vmctl:
	APP_NAME=vmctl $(MAKE) package-via-docker

package-vmctl-pure:
	APP_NAME=vmctl $(MAKE) package-via-docker-pure

package-vmctl-amd64:
	APP_NAME=vmctl $(MAKE) package-via-docker-amd64

package-vmctl-arm:
	APP_NAME=vmctl $(MAKE) package-via-docker-arm

package-vmctl-arm64:
	APP_NAME=vmctl $(MAKE) package-via-docker-arm64

package-vmctl-ppc64le:
	APP_NAME=vmctl $(MAKE) package-via-docker-ppc64le

package-vmctl-386:
	APP_NAME=vmctl $(MAKE) package-via-docker-386

publish-vmctl:
	APP_NAME=vmctl $(MAKE) publish-via-docker

vmctl-amd64:
	CGO_ENABLED=1 GOARCH=amd64 $(MAKE) vmctl-local-with-goarch

vmctl-arm:
	CGO_ENABLED=0 GOARCH=arm $(MAKE) vmctl-local-with-goarch

vmctl-arm64:
	CGO_ENABLED=0 GOARCH=arm64 $(MAKE) vmctl-local-with-goarch

vmctl-ppc64le:
	CGO_ENABLED=0 GOARCH=ppc64le $(MAKE) vmctl-local-with-goarch

vmctl-386:
	CGO_ENABLED=0 GOARCH=386 $(MAKE) vmctl-local-with-goarch

vmctl-local-with-goarch:
	APP_NAME=vmctl $(MAKE) app-local-with-goarch

vmctl-pure:
	APP_NAME=vmctl $(MAKE) app-local-pure

=== deployment/docker/Makefile ===
# All these commands must run from repository root.

DOCKER_NAMESPACE := victoriametrics

ROOT_IMAGE ?= alpine:3.13.1
CERTS_IMAGE := alpine:3.13.1
GO_BUILDER_IMAGE := golang:1.15.7
BUILDER_IMAGE := local/builder:2.0.0-$(shell echo $(GO_BUILDER_IMAGE) | tr : _)
BASE_IMAGE := local/base:1.1.1-$(shell echo $(ROOT_IMAGE) | tr : _)-$(shell echo $(CERTS_IMAGE) | tr : _)

package-base:
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(BASE_IMAGE)$$') \
		|| docker build -t $(BASE_IMAGE) \
			--build-arg root_image=$(ROOT_IMAGE) \
			--build-arg certs_image=$(CERTS_IMAGE) \
			deployment/docker/base

package-builder:
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(BUILDER_IMAGE)$$') \
		|| docker build -t $(BUILDER_IMAGE) \
			--build-arg go_builder_image=$(GO_BUILDER_IMAGE) \
			deployment/docker/builder

app-via-docker: package-base package-builder
	mkdir -p gocache-for-docker
	docker run --rm \
		--user $(shell id -u):$(shell id -g) \
		--mount type=bind,src="$(shell pwd)",dst=/VictoriaMetrics \
		-w /VictoriaMetrics \
		--mount type=bind,src="$(shell pwd)/gocache-for-docker",dst=/gocache \
		--env GOCACHE=/gocache \
		--env GO111MODULE=on \
		$(DOCKER_OPTS) \
		$(BUILDER_IMAGE) \
		go build $(RACE) -mod=vendor -trimpath \
			-ldflags "-extldflags '-static' $(GO_BUILDINFO)" \
			-tags 'netgo osusergo nethttpomithttp2' \
			-o bin/$(APP_NAME)$(APP_SUFFIX)-prod $(PKG_PREFIX)/app/$(APP_NAME)

package-via-docker:
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(APP_SUFFIX)$(RACE)$$') || (\
		$(MAKE) app-via-docker && \
		docker build \
			--build-arg src_binary=$(APP_NAME)$(APP_SUFFIX)-prod \
			--build-arg base_image=$(BASE_IMAGE) \
			-t $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(APP_SUFFIX)$(RACE) \
			-f app/$(APP_NAME)/deployment/Dockerfile bin)

package-manifest: \
		package-via-docker-amd64 \
		package-via-docker-arm \
		package-via-docker-arm64 \
		package-via-docker-ppc64le \
		package-via-docker-386
	$(MAKE) package-manifest-internal

package-manifest-internal:
	docker push $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-amd64$(RACE)
	docker push $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-arm$(RACE)
	docker push $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-arm64$(RACE)
	docker push $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-ppc64le$(RACE)
	docker push $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-386$(RACE)
	DOCKER_CLI_EXPERIMENTAL=enabled docker manifest create --amend $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(RACE) \
				$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-amd64$(RACE) \
				$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-arm$(RACE) \
				$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-arm64$(RACE) \
				$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-ppc64le$(RACE) \
				$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-386$(RACE)
	GOARCH=amd64 $(MAKE) package-manifest-annotate-goarch
	GOARCH=arm $(MAKE) package-manifest-annotate-goarch
	GOARCH=arm64 $(MAKE) package-manifest-annotate-goarch
	GOARCH=ppc64le $(MAKE) package-manifest-annotate-goarch
	GOARCH=386 $(MAKE) package-manifest-annotate-goarch

package-manifest-annotate-goarch:
	DOCKER_CLI_EXPERIMENTAL=enabled docker manifest annotate $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(RACE) \
				$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-$(GOARCH)$(RACE) --os linux --arch $(GOARCH)

publish-via-docker: package-manifest
	docker tag $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-amd64$(RACE) $(DOCKER_NAMESPACE)/$(APP_NAME):latest-amd64$(RACE)
	docker tag $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-arm$(RACE) $(DOCKER_NAMESPACE)/$(APP_NAME):latest-arm$(RACE)
	docker tag $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-arm64$(RACE) $(DOCKER_NAMESPACE)/$(APP_NAME):latest-arm64$(RACE)
	docker tag $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-ppc64le$(RACE) $(DOCKER_NAMESPACE)/$(APP_NAME):latest-ppc64le$(RACE)
	docker tag $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)-386$(RACE) $(DOCKER_NAMESPACE)/$(APP_NAME):latest-386$(RACE)
	PKG_TAG=latest $(MAKE) package-manifest-internal
	DOCKER_CLI_EXPERIMENTAL=enabled docker manifest push --purge $(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(RACE)
	DOCKER_CLI_EXPERIMENTAL=enabled docker manifest push --purge $(DOCKER_NAMESPACE)/$(APP_NAME):latest$(RACE)

run-via-docker: package-via-docker
	docker run -it --rm \
		--user $(shell id -u):$(shell id -g) \
		--net host \
		$(DOCKER_OPTS) \
		$(DOCKER_NAMESPACE)/$(APP_NAME):$(PKG_TAG)$(APP_SUFFIX)$(RACE) $(ARGS)

app-via-docker-goarch:
	APP_SUFFIX='-$(GOARCH)' \
	DOCKER_OPTS='--env CGO_ENABLED=$(CGO_ENABLED) --env GOOS=linux --env GOARCH=$(GOARCH)' \
	$(MAKE) app-via-docker

app-via-docker-goarch-cgo:
	CGO_ENABLED=1 $(MAKE) app-via-docker-goarch

app-via-docker-goarch-nocgo:
	CGO_ENABLED=0 $(MAKE) app-via-docker-goarch

app-via-docker-pure:
	APP_SUFFIX='-pure' DOCKER_OPTS='--env CGO_ENABLED=0' $(MAKE) app-via-docker

app-via-docker-amd64:
	GOARCH=amd64 $(MAKE) app-via-docker-goarch-cgo

app-via-docker-arm:
	GOARCH=arm $(MAKE) app-via-docker-goarch-nocgo

app-via-docker-arm64:
	GOARCH=arm64 $(MAKE) app-via-docker-goarch-nocgo

app-via-docker-ppc64le:
	GOARCH=ppc64le $(MAKE) app-via-docker-goarch-nocgo

app-via-docker-386:
	GOARCH=386 $(MAKE) app-via-docker-goarch-nocgo

package-via-docker-goarch:
	APP_SUFFIX='-$(GOARCH)' \
	DOCKER_OPTS='--env CGO_ENABLED=$(CGO_ENABLED) --env GOOS=linux --env GOARCH=$(GOARCH)' \
	$(MAKE) package-via-docker

package-via-docker-goarch-cgo:
	CGO_ENABLED=1 $(MAKE) package-via-docker-goarch

package-via-docker-goarch-nocgo:
	CGO_ENABLED=0 $(MAKE) package-via-docker-goarch

package-via-docker-pure:
	APP_SUFFIX='-pure' DOCKER_OPTS='--env CGO_ENABLED=0' $(MAKE) package-via-docker

package-via-docker-amd64:
	GOARCH=amd64 $(MAKE) package-via-docker-goarch-cgo

package-via-docker-arm:
	GOARCH=arm $(MAKE) package-via-docker-goarch-nocgo

package-via-docker-arm64:
	GOARCH=arm64 $(MAKE) package-via-docker-goarch-nocgo

package-via-docker-ppc64le:
	GOARCH=ppc64le $(MAKE) package-via-docker-goarch-nocgo

package-via-docker-386:
	GOARCH=386 $(MAKE) package-via-docker-goarch-nocgo

remove-docker-images:
	docker image ls --format '{{.Repository}}\t{{.ID}}' | grep $(DOCKER_NAMESPACE)/ | grep -v /builder | awk '{print $$2}' | xargs docker image rm -f

=== ports/OpenBSD/VictoriaMetrics/Makefile ===
# $OpenBSD: Makefile,v $

COMMENT =		fast, cost-effective and scalable time series database

GH_ACCOUNT =		VictoriaMetrics
GH_PROJECT =		VictoriaMetrics
GH_TAGNAME =		v1.46.0

CATEGORIES =		sysutils

HOMEPAGE =		https://victoriametrics.com/

MAINTAINER =		VictoriaMetrics <info@victoriametrics.com>

# Apache License 2.0
PERMIT_PACKAGE =	Yes

WANTLIB =		c pthread

USE_GMAKE =		Yes

MODULES =		lang/go
MODGO_GOPATH =		${MODGO_WORKSPACE}
SUBST_VARS =		VARBASE

do-build:
	cd ${WRKSRC} && GOOS=openbsd ${MAKE_ENV} ${MAKE_PROGRAM} victoria-metrics-pure
	cd ${WRKSRC} && GOOS=openbsd ${MAKE_ENV} ${MAKE_PROGRAM} vmbackup
	cd ${WRKSRC} && GOOS=openbsd ${MAKE_ENV} ${MAKE_PROGRAM} vmrestore

do-install:
	${INSTALL_PROGRAM} ./pkg/vmlogger.pl ${PREFIX}/bin/vmetricslogger.pl
	${INSTALL_PROGRAM} ${WRKSRC}/bin/victoria-metrics-pure ${PREFIX}/bin/vmetrics
	${INSTALL_PROGRAM} ${WRKSRC}/bin/vmbackup ${PREFIX}/bin/vmetricsbackup
	${INSTALL_PROGRAM} ${WRKSRC}/bin/vmrestore ${PREFIX}/bin/vmetricsrestore
	${INSTALL_DATA_DIR} ${PREFIX}/share/doc/vmetrics/
	${INSTALL_DATA} ${WRKSRC}/README.md ${PREFIX}/share/doc/vmetrics/
	${INSTALL_DATA} ${WRKSRC}/LICENSE ${PREFIX}/share/doc/vmetrics/
	${INSTALL_DATA} ${WRKSRC}/docs/* ${PREFIX}/share/doc/vmetrics/

.include <bsd.port.mk>

=== debian/changelog ===
victoriametrics (1.53.1+ds-1) unstable; urgency=medium

  * New upstream release.
    - Imports vmctl tool.

 -- Guillem Jover <gjover@sipwise.com>  Mon, 08 Feb 2021 23:15:20 +0100

victoriametrics (1.52.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Move note about license location on Debian systems into a Comment field.
  * Switch from /var/run to /run.
  * Fix coding style in init script.
  * Use '' instead of unbalanced `' in text.
  * Ignore test suite errors on non-amd64,i386,armel due to floating point
    checks missing epsilon handling in comparison.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 26 Jan 2021 23:41:54 +0100

victoriametrics (1.51.0+ds-3) unstable; urgency=medium

  * Mark packages as Multi-Arch:foreign.
  * Update option documentation in default file.
  * Update copyright years.

 -- Guillem Jover <gjover@sipwise.com>  Wed, 06 Jan 2021 01:59:31 +0100

victoriametrics (1.51.0+ds-2) unstable; urgency=medium

  * Rename DAEMON_ARGS to ARGS in default file to match other prometheus
    packages.

 -- Guillem Jover <gjover@sipwise.com>  Tue, 05 Jan 2021 19:56:47 +0100

victoriametrics (1.51.0+ds-1) unstable; urgency=medium

  * New upstream release.
    - Bump golang-github-victoriametrics-metricsql-dev Build-Depends to 0.9.1.

 -- Guillem Jover <gjover@sipwise.com>  Mon, 28 Dec 2020 18:18:00 +0100

victoriametrics (1.50.1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #953666)

 -- Guillem Jover <gjover@sipwise.com>  Thu, 17 Dec 2020 02:02:05 +0100

=== debian/control ===
Source: victoriametrics
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Guillem Jover <gjover@sipwise.com>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-github-aws-aws-sdk-go-dev,
 golang-github-cespare-xxhash-dev (>= 2.1.1),
 golang-github-golang-snappy-dev,
 golang-github-klauspost-compress-dev (>= 1.9.5),
 golang-github-urfave-cli-v2-dev,
 golang-github-valyala-fastjson-dev (>= 1.6.1),
 golang-github-valyala-fastrand-dev <!nocheck>,
 golang-github-valyala-fasttemplate-dev,
 golang-github-valyala-gozstd-dev,
 golang-github-valyala-histogram-dev,
 golang-github-valyala-quicktemplate-dev,
 golang-github-victoriametrics-fastcache-dev,
 golang-github-victoriametrics-metrics-dev (>= 1.12.3),
 golang-github-victoriametrics-metricsql-dev (>= 0.9.1),
 golang-golang-x-oauth2-google-dev,
 golang-golang-x-sys-dev,
 golang-google-api-dev (>= 0.15.0),
 golang-google-cloud-dev (>= 0.49.0),
 golang-gopkg-yaml.v2-dev,
# Needed by vendored module (github.com/cheggaaa/pb/v3/)
 golang-github-fatih-color-dev,
 golang-github-mattn-go-colorable-dev,
 golang-github-mattn-go-isatty-dev,
 golang-github-mattn-go-runewidth-dev,
 golang-github-vividcortex-ewma-dev,
# Needed by vendored module (github.com/prometheus/prometheus/)
 golang-github-go-kit-kit-dev,
 golang-github-oklog-ulid-dev,
 golang-github-pkg-errors-dev,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-common-dev,
 golang-go.uber-atomic-dev,
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/go-team/packages/victoriametrics
Vcs-Git: https://salsa.debian.org/go-team/packages/victoriametrics.git
Homepage: https://github.com/VictoriaMetrics/VictoriaMetrics
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/VictoriaMetrics/VictoriaMetrics

Package: victoria-metrics
Architecture: any
Multi-Arch: foreign
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: fast, cost-effective and scalable time series database
 VictoriaMetrics is a fast, cost-effective and scalable time-series database.
 It can be used as long-term remote storage for Prometheus.
 .
 Prominent features:
  * Supports Prometheus querying API, so it can be used as Prometheus
    drop-in replacement in Grafana. VictoriaMetrics implements MetricsQL
    query language, which is inspired by PromQL.
  * Supports global query view. Multiple Prometheus instances may write
    data into VictoriaMetrics. Later this data may be used in a single query.
  * High performance and good scalability for both inserts and selects.
    Outperforms InfluxDB and TimescaleDB by up to 20x.
  * Uses 10x less RAM than InfluxDB when working with millions of unique time
    series (aka high cardinality).
  * Optimized for time series with high churn rate. Think about
    prometheus-operator metrics from frequent deployments in Kubernetes.
  * High data compression, so up to 70x more data points may be crammed into
    limited storage comparing to TimescaleDB.
  * Optimized for storage with high-latency IO and low IOPS (HDD and network
    storage in AWS, Google Cloud, Microsoft Azure, etc).
  * A single-node VictoriaMetrics may substitute moderately sized clusters
    built with competing solutions such as Thanos, M3DB, Cortex, InfluxDB or
    TimescaleDB.
  * Easy operation:
    - VictoriaMetrics consists of a single small executable without external
      dependencies.
    - All the configuration is done via explicit command-line flags with
      reasonable defaults.
    - All the data is stored in a single directory pointed by
      -storageDataPath flag.
    - Easy and fast backups from instant snapshots to S3 or GCS with
      vmbackup / vmrestore.
    - Data migration between VictoriaMetrics, Prometheus and InfluxDB with
      vmctl.
  * Storage is protectedfrom corruption on unclean shutdown (i.e. OOM,
    hardware reset or kill -9) thanks to the storage architecture.
  * Supports metrics' scraping, ingestion and backfilling (#backfilling)
    via the following protocols:
    - Metrics from Prometheus exporters such as node_exporter.
    - Prometheus remote write API
    - InfluxDB line protocol
    - Graphite plaintext protocol with tags if -graphiteListenAddr is set.
    - OpenTSDB put message if -opentsdbListenAddr is set.
    - HTTP OpenTSDB /api/put requests if -opentsdbHTTPListenAddr is set.
    - /api/v1/import.
  * Ideally works with big amounts of time series data from Kubernetes, IoT
    sensors, connected cars, industrial telemetry, financial data and
    various Enterprise workloads.
  * Has open source cluster version.

Package: golang-github-victoriametrics-victoriametrics-dev
Section: golang
Architecture: all
Multi-Arch: foreign
Depends:
 golang-github-aws-aws-sdk-go-dev,
 golang-github-cespare-xxhash-dev (>= 2.1.1),
 golang-github-golang-snappy-dev,
 golang-github-klauspost-compress-dev (>= 1.9.5),
 golang-github-valyala-fasttemplate-dev,
 golang-golang-x-oauth2-google-dev,
 golang-golang-x-sys-dev,
 golang-google-api-dev (>= 0.15.0),
 golang-google-cloud-dev (>= 0.49.0),
 golang-gopkg-yaml.v2-dev,
 ${misc:Depends},
Description: fast, cost-effective and scalable time series database (library)
 This package provides the library code for VictoriaMetrics.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 i386 armel))
override_dh_auto_test:
	# Ignore errors due to floating point comparisons w/o epsilon.
	-dh_auto_test
endif

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%victoriametrics-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha|cluster)[.]?(\d*)$/\$1~\$2\$3/,\
      dversionmangle=s/\+ds\d*$//,repacksuffix=+ds1" \
  https://github.com/VictoriaMetrics/VictoriaMetrics/tags .*/v?(\d\S*)\.tar\.gz debian

## victoriametrics 1.71.0%2Bds1

=== snap/local/Makefile ===
GO_VERSION ?=1.17.3
SNAP_BUILDER_IMAGE := local/snap-builder:2.0.0-$(shell echo $(GO_VERSION) | tr :/ __)


# truncate pkg_tag, snap has limitations for name length
SNAP_TAG := $(shell echo "$(PKG_TAG)" | cut -b1-31 )

snap-builder-image:
	(docker image ls --format '{{.Repository}}:{{.Tag}}' | grep -q '$(SNAP_BUILDER_IMAGE)$$') \
	|| docker build \
		--build-arg GO_VERSION=$(GO_VERSION) \
		--tag $(SNAP_BUILDER_IMAGE) \
		snap/local

build-snap: snap-builder-image
	docker run --rm \
		--mount type=bind,src="$(shell pwd)",dst=/builder \
		-w /builder \
		--env PKG_TAG=$(SNAP_TAG) \
		$(SNAP_BUILDER_IMAGE) \
		bash -c 'snapcraft clean && snapcraft snap -o bin/'

release-snap: snap-builder-image build-snap
	docker run --rm \
		--mount type=bind,src=${HOME}/.snap,dst=/root/.snap \
		--mount type=bind,src="$(shell pwd)",dst=/builder \
		-w /builder \
		--env PKG_TAG=$(SNAP_TAG) \
		$(SNAP_BUILDER_IMAGE) \
		bash -c 'snapcraft login --with /root/.snap/login.json && snapcraft upload "bin/victoriametrics_$(SNAP_TAG)_multi.snap" --release beta,edge,candidate,stable'
